﻿using UnityEngine;
using System.Collections;

public class GameStatus : MonoBehaviour {

	public float m_powerBalance = 0.5f;
	public GameObject m_result;

	// Use this for initialization
	void Start () {		
	}
	
	// Update is called once per frame
	void Update () {
		if (m_powerBalance < -0.4f || m_powerBalance > 1.4f)
		{
			if (!GameObject.FindWithTag("result"))
			{
				if (m_powerBalance > 1.4f)
				{
					if (GameObject.Find("PersistentData").GetComponent<PersistentData>().m_level < 10)
					{
						m_result.GetComponent<Result>().m_resultText = "You won!";
					}
					else
					{						
						m_result.GetComponent<Result>().m_resultText = "Ultimate victory!";
					}

					
					GameObject.Find("PersistentData").GetComponent<PersistentData>().m_level++;
				}
				else
					m_result.GetComponent<Result>().m_resultText = "You lost!";

				transform.GetChild(0).particleSystem.Stop();

				Instantiate(m_result, new Vector3(0.5f, 0.55f, 0.0f), Quaternion.identity);
			}
		}

		bool allDead = true;
		GameObject[] players = GameObject.FindGameObjectsWithTag("Player");
		for (int i = 0; i < players.Length; i++)
		{
			if (players[i].GetComponent<PlayerControl>().m_health > 0.0f)
			{
				allDead = false;
			}
		}

		if (allDead && !GameObject.FindWithTag("result"))
		{
			m_result.GetComponent<Result>().m_resultText = "Draw!";
			
			Instantiate(m_result, new Vector3(0.5f, 0.55f, 0.0f), Quaternion.identity);
		}
	}

	void FixedUpdate()
	{		
		Vector3 pos = transform.GetChild(0).transform.position;
		pos.x = (m_powerBalance - 0.5f) * 10;
		transform.GetChild(0).transform.position = pos;
	}
}
