﻿using UnityEngine;
using System.Collections;

public class PlayerControl : MonoBehaviour {

	public float m_health = 1.0f;
	public float m_powerLevel = 1;

	public KeyCode m_increasePower;
	public KeyCode m_decreasePower;

	
	public string[] m_keys;
	public int m_vowelcount = 5;
	public int[] m_keysToPress = new int[10];
	public float m_cooldown = 0.0f;
	public int m_keysTyped = 0;
	public int m_wordIdx = 0;
	public int m_wordLetterIdx = 0;

	public string[] m_words;

	public int m_direction = 0;

	public int m_aiLevel = 0;
	public bool m_phase = false;

	private GameStatus m_gameStatus;
	public GameObject m_result;

	public GameObject m_explosion;

	// Use this for initialization
	void Start () {
		m_gameStatus = GameObject.Find("GameStatus").GetComponent<GameStatus>();
		if (m_aiLevel == 1)
			m_aiLevel = GameObject.Find("PersistentData").GetComponent<PersistentData>().m_level;

		m_wordIdx = Random.Range(0, m_words.Length);

		m_keysToPress = new int[m_wordIdx];

		for (int i = 0; i < m_keysToPress.Length; i++)
		{
			if (m_phase)
				m_keysToPress[i] = Random.Range(0, m_vowelcount);
			else
				m_keysToPress[i] = Random.Range(m_vowelcount, m_keys.Length);
			m_phase = !m_phase;
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (GameObject.Find("PersistentData").GetComponent<PersistentData>().m_level > 5)
		{
			if (m_aiLevel == 0)
				particleSystem.startColor = new Color(1.0f - m_health, m_health, 0.0f, 0.5f);
			transform.GetChild(0).GetChild(0).particleSystem.startColor = new Color(1.0f - m_health, m_health, 0.0f, 0.55f - m_health * 0.5f);
			return;
		}

		m_cooldown -= Time.deltaTime;

		if (m_aiLevel == 0)
		{

			//if (Input.GetKeyDown(KeyCode.Space))
			//	m_powerLevel += 1;
			//else

			for (int i = 0; i < m_keys.Length; i++)
			{
				
				if (Input.GetKeyDown(m_keys[i]) && m_cooldown <= 0.0f)
				{
					//if (m_keysToPress[0] == i)
					if (m_words[m_wordIdx].Substring(m_wordLetterIdx, 1) == m_keys[i])
					{
						/*for (int j = 0; j < m_keysToPress.Length - 1; j++)
						{
							m_keysToPress[j] = m_keysToPress[j + 1];
						}

						if (m_phase)
							m_keysToPress[m_keysToPress.Length - 1] = Random.Range(0, m_vowelcount);
						else
							m_keysToPress[m_keysToPress.Length - 1] = Random.Range(m_vowelcount, m_keys.Length);

						m_phase = !m_phase;*/
						m_wordLetterIdx++;

						if (m_wordLetterIdx >= m_words[m_wordIdx].Length)
						{
							m_powerLevel += 0.5f * m_words[m_wordIdx].Length;
							m_wordIdx = Random.Range(0, m_words.Length);
							m_wordLetterIdx = 0;

							if (m_powerLevel > 10 && Random.Range(0.0f, 1.0f) < 0.4f)
							{
								GameObject.Find("Over9k").GetComponent<TextMesh>().transform.position = new Vector3(0.0f, 3.0f, 10.0f);
							}
						}
						else							
							m_powerLevel += 0.25f;
						
						if (m_words[m_wordIdx].Substring(m_wordLetterIdx, 1) == " ")
							m_wordLetterIdx++;

					}
					else
					{
						m_cooldown = 0.01f;
					}
				}
			}
			m_powerLevel -= Time.deltaTime * 2.0f;

			
			GameObject.Find("Over9k").GetComponent<TextMesh>().transform.position -= new Vector3(0.0f, 0.0f, 20.0f * Time.deltaTime);

			string keys = "";
			for (int i = 0; i < m_wordLetterIdx; i++)
				keys += "  ";
			for (int i = m_wordLetterIdx; i < m_words[m_wordIdx].Length; i++)
			{
				keys += m_words[m_wordIdx].Substring(i, 1).ToUpper();
			}

			GameObject.Find("LeftQTE").GetComponent<TextMesh>().text = "Write: " + keys;
			GameObject.Find("LeftQTE").GetComponent<TextMesh>().color = (m_cooldown >= 0.0f ? new Color(1.0f, 0.0f, 0.0f, 0.5f) : new Color(1.0f, 1.0f, 1.0f, 1.0f));

			//if (Input.GetKey(m_decreasePower))
				//m_powerLevel -= Time.deltaTime * 5;
		}
		float m_humanPower = GameObject.Find("Player1").GetComponent<PlayerControl>().m_powerLevel;
		
		/*switch (m_aiLevel)
		{
			// Tutorial
		case 1:	m_powerLevel = Mathf.Clamp(Time.timeSinceLevelLoad * 2.0f, 3, 3);						break;
		case 2:	m_powerLevel = Mathf.Clamp(Time.timeSinceLevelLoad * 1.0f, 3, 5);						break;
		case 3:	m_powerLevel = Mathf.Clamp(Time.timeSinceLevelLoad * 1.0f, 3, 7);					break;
			
			// Can't win by holding down increase
		case 4:	m_powerLevel = Mathf.Clamp(Time.timeSinceLevelLoad * 3.7f, 0, 20);				break;		
		case 5:	m_powerLevel = Mathf.Clamp(Time.timeSinceLevelLoad * 5f, 0, 15);				break;
			
			// Variation in usage
		case 6:	m_powerLevel = Mathf.Abs(Mathf.Cos(Time.timeSinceLevelLoad * 0.15f)) * 15.0f;	break;
		case 7:	m_powerLevel = Mathf.Cos(Time.timeSinceLevelLoad * 0.3f) * 5.0f + Mathf.Abs(Mathf.Sin(Time.timeSinceLevelLoad * 0.2f)) * 15.0f;	break;
			
			
			// Mimic + variation
		case 8:m_powerLevel = m_humanPower + Mathf.Sin(Time.timeSinceLevelLoad * 1.5f) * 10.0f;	break;
			
			// Mimic player
		case 9:	m_powerLevel = m_humanPower - 2.5f;	break;	
		case 10: m_powerLevel = m_humanPower - 1.5f; break;		
			
		}*/
		if (m_aiLevel > 0)
		{
			m_powerLevel = Mathf.Clamp(Time.timeSinceLevelLoad * (m_aiLevel * 0.3f), 4.0f, Mathf.Clamp(m_aiLevel * 5.0f, 0, 22.0f));
			if (m_gameStatus.m_powerBalance < 0.0f)
				m_powerLevel += m_gameStatus.m_powerBalance * 20.0f;
			
			if (m_gameStatus.m_powerBalance > 1.0f)
				m_powerLevel += (m_gameStatus.m_powerBalance - 1.0f) * 10.0f;
		}

		if (m_aiLevel == 0)
			m_powerLevel = Mathf.Clamp(m_powerLevel, 1.0f, 30.0f);
		else
			m_powerLevel = Mathf.Clamp(m_powerLevel, 0.01f, 30.0f);

		if (m_health <= 0.0f)
		{
			m_powerLevel = 0;
			
			//particleSystem.emissionRate = 0;
			particleSystem.Stop();

			//transform.GetChild(0).GetChild(0).particleSystem.Stop();
		}
		else
		{
			particleSystem.emissionRate = m_powerLevel * 200 + 1000;
		}

		if (m_aiLevel > 0 && m_gameStatus.m_powerBalance > 1.4f)
		{		
			if (m_explosion != null)
			{
				Instantiate(m_explosion, transform.position, Quaternion.identity);
				m_explosion = null;
			}
			particleSystem.Stop();
		}

		if (m_aiLevel == 0 && m_gameStatus.m_powerBalance < -0.4f)
		{			
			if (m_explosion != null)
			{
				Instantiate(m_explosion, transform.position, Quaternion.identity);
				m_explosion = null;
			}
			particleSystem.Stop();
		}

		if (m_aiLevel == 0)
		{
			float scaledPowerLevel = 1 - m_powerLevel / 30.0f;
			transform.GetChild(0).GetChild(0).particleSystem.startColor = new Color(1.0f - scaledPowerLevel, scaledPowerLevel, 0.0f, 0.55f - scaledPowerLevel * 0.5f);
			particleSystem.startColor = new Color(1.0f - scaledPowerLevel, scaledPowerLevel, 0.0f, 0.5f);

			GameObject.Find("GameStatus").transform.GetChild(0).particleSystem.startColor = new Color((1.0f - scaledPowerLevel + 1.0f) / 2.0f, scaledPowerLevel / 2.0f, 0.8f, 1.0f);
		}
		else
		{
			transform.GetChild(0).GetChild(0).particleSystem.startColor = new Color(1.0f, 0.0f, 0.9f, 0.25f);
		}

		if (m_aiLevel == 0)
			GameObject.Find("PowerLevelText").GetComponent<GUIText>().text = "Power Level: " + Mathf.Floor(m_powerLevel * 500) + "\nHeat: " + Mathf.Floor((1 - m_health) * 100.0f) + "%";
		else
			GameObject.Find("EnemyPowerLevelText").GetComponent<GUIText>().text = "Enemy Power Level: " + Mathf.Floor(m_powerLevel * 500);
		
	}

	void FixedUpdate()
	{
		
		if (GameObject.Find("PersistentData").GetComponent<PersistentData>().m_level > 5)
			return;

		//if (m_aiLevel == 0)
			//if (GameObject.Find("Player2").GetComponent<PlayerControl>().m_health > 0.0f)
				//m_health -= Mathf.Pow(m_powerLevel, 1.5f) * 0.00005f;

		float distanceMultiplier = (m_gameStatus.m_powerBalance + 0.4f) / 1.8f;
		if (m_aiLevel == 0)
			distanceMultiplier = 1 - distanceMultiplier;

		//distanceMultiplier = distanceMultiplier * 0.5f + 1.0f;
		distanceMultiplier = 1.0f;

		m_gameStatus.m_powerBalance += m_direction * (m_health > 0 ? m_powerLevel + 10 : 0) * 0.001f * distanceMultiplier;

	}
}
